
#ifndef __GAME_H__
#define __GAME_H__

/* Framebuffer size */
#define FBW 320
#define FBH 200

/* Bitmaps sizes */
#define PLAYER_W 48
#define PLAYER_H 32

#define MISSILE_W 24
#define MISSILE_H 16

#define JUNK_W 56
#define JUNK_H 56

/* Samples indices */
#define MISSILE_SPL 0
#define EXPLOSION_SPL 1
#define SHIPEXPLO_SPL 2

/* Tuning */
#define PLAYER_SPEED_X  5
#define PLAYER_SPEED_Y  6
#define PLAYER_INVICIBLE_TIME 100
#define MISSILE_FREQUENCY 8
#define MISSILE_SPEED 8

#define DYING_STEPS  5
#define DYING_TICKS 2
#define DYING_TIME DYING_STEPS*DYING_TICKS

#define INVICIBLE_STEPS 8
#define INVICIBLE_TICKS 1

#define JUNK_DELTA  300

/* 50 ;  2 */
#define ENEMY_DELTA 50
#define ENEMY_DELTA_MIN 20
#define ENEMY_SPEED 2
#define ACCELERATION_MAX 2

#define NEW_LIFE_REQ    20


/* Externs */
extern unsigned short playerbitmapdata;
extern unsigned short enemybitmapdata;
extern unsigned short missilebitmapdata;
extern unsigned short exp4832bitmapdata;
extern unsigned short junkbitmapdata;

extern unsigned short logwindowbase;
 
extern char laserspldata;
extern char explosionspldata;
extern char shipexplospldata;
extern char laserspldataend;
extern char explosionspldataend;
extern char shipexplospldataend;

/* Game structures */
typedef struct
{
  int score;
  int level;  
  int nbkilled;
  int lives;
} TGameStats;

extern TGameStats gamestats;

/* Game functions */
int MenuLoop();
void GameLoop(int);

#endif /* __GAME_H__ */ 