
#ifndef __SPRITES_H__
#define __SPRITES_H__

#include "graphics.h"

typedef enum
{
  EAlive = 0,
  EDying,
  EDead,
  EInvicible
} ESpriteState;

typedef enum
{
  EMissile = 0,
  EPlayer,
  EEnemy,
  EEnemySpike,
  EEnemyCrab,
  EEnemyCross
} ESpriteType;

typedef struct
{
  CBitmap* mBitmap;
  ESpriteState mState;
  ESpriteType mType;
  CAnim mAnim;
  int mTimeOfDeath;
  int mTimeOfInvicibility;
  int mDirX;
  int mDirY;
} CSpriteState; 

void MakeSpriteState(CSpriteState*, CBitmap*, ESpriteState, ESpriteType);

void MovePlayer(CSpriteState* );
void MoveEnemies(CSpriteState* ,int);
void MoveMissiles(CSpriteState* ,int);
void MoveJunk(CBitmap*, int);

void TestPlayerFire(CSpriteState*, CSpriteState*, int);
void TestRespawnPlayer(CSpriteState*);

void TestPlayerVsEnemyCollision(CSpriteState*, CSpriteState*, int);
void TestPlayerVsJunkCollision(CSpriteState*, CBitmap*, int);
void TestMissileVsEnemyCollision(CSpriteState*, int, CSpriteState*, int);

void ExplodeSprite(CSpriteState*);
void UpdateSprites(CSpriteState*, int);
void KillSprite(CSpriteState*);

void GeneratePlayer(CSpriteState*);
void GenerateEnemies(CSpriteState*, int);
void GenerateMissiles(CSpriteState*, CSpriteState*, int);
void GenerateJunk(CBitmap*, int);


#endif /* __SPRITES_H__ */